class NoteList():
    class NoteEditor():
        def __init__(self, parent_object, note=''):    
            # Create a keyboard to use it with one of the text areas
            parent_object.destroy()
            self.filename = note
            self.objects = []
            kb = lv.keyboard(lv.scr_act())
            self.objects.append(kb)
            kb.add_event_cb(lambda e: self.kb_event_cb(e), lv.EVENT.ALL, None)
            print('creating keyboard')
            # Create a text area. The keyboard will write here
            self.ta = lv.textarea(lv.scr_act())
            self.objects.append(self.ta)
            self.ta.set_width(200)
            self.ta.align(lv.ALIGN.TOP_LEFT,0, 0)
            self.ta.add_event_cb(lambda e: self.ta_event_cb(e,kb), lv.EVENT.ALL, None)
            if note != '':
                self.ta.set_text(open("/sd/appdata/notes/" + note).read())
            kb.set_textarea(self.ta)#
            lv.scr_load(lv.scr_act())
        
        def kb_event_cb(self, e):
            global NoteList
            global n
            code = e.get_code()

            if code == lv.EVENT.READY:
                f = open("/sd/appdata/notes/" + self.filename, "w")
                f.write(self.ta.get_text())
                f.close()
                n = NoteList(self)

        def destroy(self):
            print("Destroying NoteEditor")
            for obj in self.objects:
                print(obj)
                obj.delete()

        
        def ta_event_cb(self, e, kb):
            code = e.get_code()
            ta = e.get_target()
            if code == lv.EVENT.FOCUSED:
                kb.set_textarea(ta)
                kb.clear_flag(lv.obj.FLAG.HIDDEN)
            if code == lv.EVENT.DEFOCUSED:
                kb.set_textarea(None)
                kb.add_flag(lv.obj.FLAG.HIDDEN)

    def __init__(self, parent_object):
        parent_object.destroy()
        self.objects = []
        prev_btn_x = 0
        prev_btn_y = 0
        notelist = os.listdir("/sd/appdata/notes")
        # Iterate over /sd/appdata/notes
        for note in notelist:
            btn = lv.btn(lv.scr_act())
            btn.align_to(lv.scr_act(), lv.ALIGN.TOP_LEFT, 0, prev_btn_y)
            btn.add_event_cb(self.note_click, lv.EVENT.CLICKED, None)
            prev_btn_y += 40
            label = lv.label(btn)
            label.set_text(note)
            self.objects.append(btn)

    def destroy(self):
        print("Destroying NoteList")
        for obj in self.objects:
            obj.delete()
            self.objects.remove(obj)

    def note_click(self, e):
        btn = e.get_target()
        label = btn.get_child(0)
        print("/sd/appdata/notes/" + label.get_text())
        n = self.NoteEditor(parent_object=self, note=label.get_text())
n = NoteList(launcher)
